# release file makefile for pyukiwiki 
# $Id$

all:
	@echo "PyukiWIki ${VERSION} Release Builder"
	@echo "Usage: ${MAKE} [build|prof|release|buildrelease|buildreleaseutf8|builddevel|builddevelutf8|buildcompact|buildcompactutf8|pkg|clean|realclean|cvsclean|ftp]"

version:
	@echo "PyukiWIki ${VERSION}"

BUILDMAKER=${BUILDDIR}/makesampleini.pl \
			${BUILDDIR}/Jcode-convert.pl \
			${BUILDDIR}/lang.pl \
			${BUILDDIR}/getversion.pl \
			${BUILDDIR}/build.mk \
			${BUILDDIR}/build.pl \
			${BUILDDIR}/compactmagic.pl \
			${BUILDDIR}/compressfile.pl \
			${BUILDDIR}/text.pl \
			${BUILDDIR}/makeinstaller.sh \
			${BUILDDIR}/installer.sh \
			${BUILDDIR}/installer2.sh \
			${BUILDDIR}/installer_sub.sh \
			${BUILDDIR}/b64decode.pl \
			${BUILDDIR}/base64.pl \
			${BUILDDIR}/class.JavaScriptPacker.php \
			${BUILDDIR}/example-file.php \
			${BUILDDIR}/makewikisub.pl \
			Makefile

BUILDFILES=lib/wiki_sub.cgi \
			sample/pyukiwiki.ini.cgi \
			skin/loader.js skin/loader.js.gz \
			skin/bookmark.js skin/bookmark.js.gz \
			skin/captcha.js skin/captcha.js.gz \
			skin/instag.js skin/instag.js.gz \
			skin/instag.css skin/instag.css.gz \
			skin/common.en.js skin/common.en.js.gz \
			skin/common.ja.js skin/common.ja.js.gz \
			skin/common.sjis.ja.js skin/common.sjis.ja.js.gz \
			skin/common.utf8.ja.js skin/common.utf8.ja.js.gz \
			skin/common.unicode.ja.js skin/common.unicode.ja.js.gz \
			skin/edit.js skin/edit.js.gz \
			skin/passwd.js skin/passwd.js.gz \
			skin/twitter.js skin/twitter.js.gz \
			skin/twitstat.js skin/twitstat.js.gz \
			skin/smedia.js skin/smedia.js.gz \
			skin/smedia.css skin/smedia.css.gz \
			lib/File/magic.txt lib/File/magic_compact.txt \
			skin/pyukiwiki.default.css skin/pyukiwiki.default.css.gz \
			skin/pyukiwiki.print.css skin/pyukiwiki.print.css.gz \
			skin/pyukiwikigreen.default.css skin/pyukiwikigreen.default.css.gz \
			skin/pyukiwikigreen.print.css skin/pyukiwikigreen.print.css.gz \
			skin/pyukiwikigreen.skin.cgi \
			skin/logs_viewer.css \
			sample/mikachan.default.css sample/mikachan.print.css \
			sample/mikachan.default.css.org sample/mikachan.print.css.org \
			sample/mikachan.skin.cgi \
			skin/blosxom.css \
			skin/video.js skin/video.js.gz \
			skin/flowplayer-3.2.6.min.js skin/flowplayer-3.2.6.min.js.gz \
			skin/jquery.js skin/jquery.js.gz \
			skin/videoresize.js skin/videoresize.js.gz \
			skin/video-js.css skin/video-js.css.gz \
			skin/tube.css skin/tube.css.gz \
			skin/ad.css skin/ad.css.gz \
			skin/syntaxhighlighter/shAutoloader.js skin/syntaxhighlighter/shAutoloader.js.gz \
			skin/syntaxhighlighter/shBrushAS3.js skin/syntaxhighlighter/shBrushAS3.js.gz \
			skin/syntaxhighlighter/shBrushAppleScript.js skin/syntaxhighlighter/shBrushAppleScript.js.gz \
			skin/syntaxhighlighter/shBrushBash.js skin/syntaxhighlighter/shBrushBash.js.gz \
			skin/syntaxhighlighter/shBrushCSharp.js skin/syntaxhighlighter/shBrushCSharp.js.gz \
			skin/syntaxhighlighter/shBrushColdFusion.js skin/syntaxhighlighter/shBrushColdFusion.js.gz \
			skin/syntaxhighlighter/shBrushCpp.js skin/syntaxhighlighter/shBrushCpp.js.gz \
			skin/syntaxhighlighter/shBrushCss.js skin/syntaxhighlighter/shBrushCss.js.gz \
			skin/syntaxhighlighter/shBrushDelphi.js skin/syntaxhighlighter/shBrushDelphi.js.gz \
			skin/syntaxhighlighter/shBrushDiff.js skin/syntaxhighlighter/shBrushDiff.js.gz \
			skin/syntaxhighlighter/shBrushErlang.js skin/syntaxhighlighter/shBrushErlang.js.gz \
			skin/syntaxhighlighter/shBrushGroovy.js skin/syntaxhighlighter/shBrushGroovy.js.gz \
			skin/syntaxhighlighter/shBrushJScript.js skin/syntaxhighlighter/shBrushJScript.js.gz \
			skin/syntaxhighlighter/shBrushJava.js skin/syntaxhighlighter/shBrushJava.js.gz \
			skin/syntaxhighlighter/shBrushJavaFX.js skin/syntaxhighlighter/shBrushJavaFX.js.gz \
			skin/syntaxhighlighter/shBrushPerl.js skin/syntaxhighlighter/shBrushPerl.js.gz \
			skin/syntaxhighlighter/shBrushPhp.js skin/syntaxhighlighter/shBrushPhp.js.gz \
			skin/syntaxhighlighter/shBrushPlain.js skin/syntaxhighlighter/shBrushPlain.js.gz \
			skin/syntaxhighlighter/shBrushPowerShell.js skin/syntaxhighlighter/shBrushPowerShell.js.gz \
			skin/syntaxhighlighter/shBrushPython.js skin/syntaxhighlighter/shBrushPython.js.gz \
			skin/syntaxhighlighter/shBrushRuby.js skin/syntaxhighlighter/shBrushRuby.js.gz \
			skin/syntaxhighlighter/shBrushSass.js skin/syntaxhighlighter/shBrushSass.js.gz \
			skin/syntaxhighlighter/shBrushScala.js skin/syntaxhighlighter/shBrushScala.js.gz \
			skin/syntaxhighlighter/shBrushSql.js skin/syntaxhighlighter/shBrushSql.js.gz \
			skin/syntaxhighlighter/shBrushVb.js skin/syntaxhighlighter/shBrushVb.js.gz \
			skin/syntaxhighlighter/shBrushXml.js skin/syntaxhighlighter/shBrushXml.js.gz \
			skin/syntaxhighlighter/shCore.css skin/syntaxhighlighter/shCore.css.gz \
			skin/syntaxhighlighter/shCore.js skin/syntaxhighlighter/shCore.js.gz \
			skin/syntaxhighlighter/shThemeDefault.css skin/syntaxhighlighter/shThemeDefault.css.gz \
			skin/syntaxhighlighter/shThemeDjango.css skin/syntaxhighlighter/shThemeDjango.css.gz \
			skin/syntaxhighlighter/shThemeEclipse.css skin/syntaxhighlighter/shThemeEclipse.css.gz \
			skin/syntaxhighlighter/shThemeEmacs.css skin/syntaxhighlighter/shThemeEmacs.css.gz \
			skin/syntaxhighlighter/shThemeFadeToGrey.css skin/syntaxhighlighter/shThemeFadeToGrey.css.gz \
			skin/syntaxhighlighter/shThemeMDUltra.css skin/syntaxhighlighter/shThemeMDUltra.css.gz \
			skin/syntaxhighlighter/shThemeMidnight.css skin/syntaxhighlighter/shThemeMidnight.css.gz \
			skin/syntaxhighlighter/shThemeRDark.css skin/syntaxhighlighter/shThemeRDark.css.gz

pkg:
	@${MAKE} -f ${BUILDDIR}/build.mk cvsclean
	@${MAKE} -f ${BUILDDIR}/build.mk pkgclean
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=updatecompact PKGPREFIX="-update-compact"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=update PKGPREFIX="-update-full"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=devel PKGPREFIX="-devel"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=updatedevel PKGPREFIX="-update-devel"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=compact PKGPREFIX="-compact"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgz PKGTYPE=release PKGPREFIX="-full"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=updatecompact PKGPREFIX="-update-compact"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=update PKGPREFIX="-update-full"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=devel PKGPREFIX="-devel"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=updatedevel PKGPREFIX="-update-devel"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=compact PKGPREFIX="-compact"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgtgzutf8 PKGTYPE=release PKGPREFIX="-full"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzip PKGTYPE=devel PKGPREFIX="-devel"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzipupdate PKGTYPE=updatedevel PKGPREFIX="-update-devel"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzipupdate PKGTYPE=updatecompact PKGPREFIX="-update-compact"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzipupdate PKGTYPE=update PKGPREFIX="-update-full"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzip PKGTYPE=compact PKGPREFIX="-compact"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgzip PKGTYPE=release PKGPREFIX="-full"	#euc
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8 PKGTYPE=devel PKGPREFIX="-devel"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8update PKGTYPE=updatedevel PKGPREFIX="-update-devel"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8update PKGTYPE=updatecompact PKGPREFIX="-update-compact"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8update PKGTYPE=update PKGPREFIX="-update-full"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8 PKGTYPE=compact PKGPREFIX="-compact"	#utf8
	@${MAKE} -f ${BUILDDIR}/build.mk pkgziputf8 PKGTYPE=release PKGPREFIX="-full"	#utf8

release:FORCE
	@rm -rf ${TEMP} ${RELEASE}
	@mkdir ${TEMP} 2>/dev/null
	@mkdir ${RELEASE} 2>/dev/null
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-full 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-compact 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update-compact 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-devel 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update-devel 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-full-utf8 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update-utf8 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-compact-utf8 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update-compact-utf8 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-devel-utf8 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-update-devel-utf8 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-full"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-full "release" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-compact"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-compact "compact" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-update"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update "update" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-update-compact"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update-compact "updatecompact" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-devel"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-devel "devel" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-update-devel"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update-devel  "updatedevel" lf >/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-full-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-full-utf8 "release" lf utf8 >/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-compact-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-compact-utf8 "compact" lf utf8 >/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-update-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update-utf8 "update" lf utf8 >/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-update-compact-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update-compact-utf8 "updatecompact" lf utf8 >/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-devel-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-devel-utf8 "devel" lf utf8 >/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-update-devel-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-update-devel-utf8  "updatedevel" lf utf8 >/dev/null	#utf8


releasedevel:FORCE
	@rm -rf ${TEMP} ${RELEASE}
	@mkdir ${TEMP} 2>/dev/null
	@mkdir ${RELEASE} 2>/dev/null
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-devel 2>/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-devel all plugin"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-devel "devel" lf euc all >/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}-devel-utf8 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-devel-utf8 all plugin"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}-devel-utf8 "devel" lf utf8  all >/dev/null	#utf8

buildall:FORCE	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-devel(all)"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "devel" lf euc all>/dev/null	#euc

buildallutf8:FORCE	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-devel-utf8(all)"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "devel" lf utf8 all>/dev/null	#utf8

builddevel:FORCE	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-devel"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "devel" lf >/dev/null	#euc

builddevelutf8:FORCE	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-devel-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "devel" lf utf8 >/dev/null	#utf8

buildrelease:FORCE	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-full"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "release" lf >/dev/null	#euc

buildreleaseutf8:FORCE	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-full-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "release" lf utf8 >/dev/null	#utf8

buildcompact:FORCE	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@echo "Building ${PKGNAME}-${VERSION}-compact"	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "compact" lf >/dev/null	#euc

buildcompactutf8:FORCE	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@echo "Building ${PKGNAME}-${VERSION}-compact-utf8"	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/ "compact" lf utf8 >/dev/null	#utf8

pkgtgz:	#euc
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}"	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} 2>/dev/null	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} ${PKGTYPE} lf >/dev/null	#euc
	@echo "Taping ${PKGNAME}-${VERSION}${PKGPREFIX}.tar"	#euc
	@cd ${RELEASE} && ${TAR} ${PKGNAME}-${VERSION}${PKGPREFIX}.tar * >/dev/null 2>/dev/null	#euc
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz"	#euc
	@cd ${RELEASE} && ${GZIP_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz ${PKGNAME}-${VERSION}${PKGPREFIX}.tar >/dev/null 2>/dev/null	#euc
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.bz2"	#euc
	@cd ${RELEASE} && ${BZIP2_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.bz2 ${PKGNAME}-${VERSION}${PKGPREFIX}.tar >/dev/null 2>/dev/null	#euc
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.xz"	#euc
	@cd ${RELEASE} && ${XZ_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}.tar.xz ${PKGNAME}-${VERSION}${PKGPREFIX}.tar >/dev/null 2>/dev/null	#euc
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#euc
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#euc
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.bz2 ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#euc
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.xz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#euc
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz	#euc
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.bz2	#euc
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.xz	#euc
	@echo "Make installer ${PKGNAME}-${VERSION}${PKGPREFIX}"	#euc
	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}_installer ${VERSION} ${PKGPREFIX} gz shar EUC	#euc
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}_installer_gz_uu ${VERSION} ${PKGPREFIX} gz uu EUC	#euc
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.bz2 ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}_installer_bz2_b64 ${VERSION} ${PKGPREFIX} bz2 b64 EUC	#euc
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.tar.xz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}_installer_xz_b64 ${VERSION} ${PKGPREFIX} xz b64 EUC	#euc

pkgzip:	#euc
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}"	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} 2>/dev/null	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} ${PKGTYPE} crlf >/dev/null	#euc
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}.zip"	#utf8
	@cd ${RELEASE} && ${ZIP_7Z} zip.zip ${PKGNAME}-${VERSION}${PKGPREFIX}/* ${PKGNAME}-${VERSION}${PKGPREFIX}/.htaccess >/dev/null 2>/dev/null	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#euc
	@cp ${RELEASE}/zip.zip ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.zip	#euc
	@rm ${RELEASE}/zip.zip	#euc

pkgzipupdate:	#euc
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}"	#euc
	@rm -rf ${TEMP} ${RELEASE}	#euc
	@mkdir ${TEMP} 2>/dev/null	#euc
	@mkdir ${RELEASE} 2>/dev/null	#euc
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} 2>/dev/null	#euc
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX} ${PKGTYPE} crlf >/dev/null	#euc
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}.zip"	#euc
	@cd ${RELEASE} && ${ZIP_7Z} zip.zip ${PKGNAME}-${VERSION}${PKGPREFIX}/* >/dev/null 2>/dev/null	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#euc
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#euc
	@cp ${RELEASE}/zip.zip ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}.zip	#euc
	@rm ${RELEASE}/zip.zip	#euc

pkgtgzutf8:	#utf8
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8"	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 2>/dev/null	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 ${PKGTYPE} lf utf8 >/dev/null	#utf8
	@echo "Taping ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar"	#euc
	@cd ${RELEASE} && ${TAR} ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar * >/dev/null 2>/dev/null	#utf8
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz"	#utf8
	@cd ${RELEASE} && ${GZIP_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar >/dev/null 2>/dev/null	#utf8
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.bz2"	#utf8
	@cd ${RELEASE} && ${BZIP2_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.bz2 ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar >/dev/null 2>/dev/null	#utf8
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.xz"	#utf8
	@cd ${RELEASE} && ${XZ_7Z} ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.xz ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar >/dev/null 2>/dev/null	#utf8
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#utf8
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#utf8
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.bz2 ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#utf8
	@cp ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.xz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}	#utf8
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz	#utf8
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.bz2	#utf8
	@rm ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.xz	#utf8
	@echo "Make installer ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8"	#utf8
	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8_installer ${VERSION} ${PKGPREFIX} gz shar UTF-8 #utf8
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.gz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8_installer_gz_uu ${VERSION} ${PKGPREFIX} gz uu UTF-8 #utf8
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.bz2 ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8_installer_bz2_b64 ${VERSION} ${PKGPREFIX} bz2 b64 UTF-8 #utf8
#	@${SH} ${BUILDDIR}/makeinstaller.sh "${ZIP_7Z}" "${7Z_7Z}" ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.tar.xz ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8_installer_xz_b64 ${VERSION} ${PKGPREFIX} xz b64 UTF-8 #utf8

pkgziputf8:	#utf8
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8"	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 2>/dev/null	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 ${PKGTYPE} crlf utf8>/dev/null	#utf8
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.zip"	#utf8
	@cd ${RELEASE} && ${ZIP_7Z} zip.zip ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8/* ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8/.htaccess >/dev/null 2>/dev/null	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#utf8
	@cp ${RELEASE}/zip.zip ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.zip	#utf8
	@rm ${RELEASE}/zip.zip	#utf8

pkgziputf8update:	#utf8
	@echo "Building ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8"	#utf8
	@rm -rf ${TEMP} ${RELEASE}	#utf8
	@mkdir ${TEMP} 2>/dev/null	#utf8
	@mkdir ${RELEASE} 2>/dev/null	#utf8
	@mkdir ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 2>/dev/null	#utf8
	@${PERL} ${BUILDDIR}/build.pl ${RELEASE}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8 ${PKGTYPE} crlf utf8>/dev/null	#utf8
	@echo "Compress ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.zip"	#utf8
	@cd ${RELEASE} && ${ZIP_7Z} zip.zip ${PKGNAME}-${VERSION}${PKGPREFIX}-utf8/* >/dev/null 2>/dev/null	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}");' 2>/dev/null	#utf8
	@${PERL} -e 'mkdir("${ARCHIVEDIR}/${PKGNAME}-${VERSION}");' 2>/dev/null	#utf8
	@cp ${RELEASE}/zip.zip ${ARCHIVEDIR}/${PKGNAME}-${VERSION}/${PKGNAME}-${VERSION}${PKGPREFIX}-utf8.zip	#utf8
	@rm ${RELEASE}/zip.zip	#utf8

clean:
	@echo "Cleaning work directorys"
	@rm -rf ${TEMP} ${RELEASE}

pkgclean:
	@echo "Cleaning Arvhive directorys"
	@rm -rf ${TEMP} ${RELEASE} ${ARCHIVEDIR}

realclean:
	@echo "Cleaning all build files"
	@rm -rf ${TEMP} ${RELEASE} ${ARCHIVEDIR}
	@rm -rf ${BUILDFILES}

cvsclean:
	@echo "Cleaning CVS tags"
	@for p in `find .|grep CVS`; do rm -rf $${p}; done

touch:FORCE
	@echo "Update time stamp for build files"
	@touch ${BUILDFILES}

prof:FORCE
	@${PERL} -d:DProf index.cgi >/dev/null 2>/dev/null
	@dprofpp -O 30
	@rm -f tmon.out

build:FORCE ${BUILDFILES} ${BUILDMAKER}

FORCE:

lib/File/magic.txt: lib/File/magic.txt.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compactmagic.pl lib/File/magic.txt.src>lib/File/magic.txt

lib/File/magic_compact.txt: lib/File/magic.txt.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compactmagic.pl lib/File/magic.txt.src compact>lib/File/magic_compact.txt

skin/common.sjis.ja.js: skin/common.ja.js ${BUILDMAKER}
	${PERL} ${BUILDDIR}/Jcode-convert.pl sjis skin/common.sjis.ja.js skin/common.ja.js

skin/common.unicode.ja.js: skin/common.ja.js ${BUILDMAKER}
	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/common.unicode.ja.js.tmp skin/common.ja.js.src
	${PERL} ${BUILDDIR}/utf16.pl skin/common.unicode.ja.js.tmp skin/common.unicode.ja.js.tmp2
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/common.unicode.ja.js skin/common.unicode.ja.js.tmp2
	rm -f skin/common.unicode.ja.js.tmp skin/common.unicode.ja.js.tmp2

skin/common.utf8.ja.js: skin/common.ja.js ${BUILDMAKER}
	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/common.utf8.ja.js skin/common.ja.js

skin/edit.js: skin/edit.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/edit.js.tmp skin/edit.js.src
	${PERL} ${BUILDDIR}/utf16.pl skin/edit.js.tmp skin/edit.js.tmp2
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/edit.js skin/edit.js.tmp2
	rm -f skin/edit.js.tmp skin/edit.js.tmp2


sample/pyukiwiki.ini.cgi: pyukiwiki.ini.cgi ${BUILDMAKER}
	${PERL} ${BUILDDIR}/makesampleini.pl > sample/pyukiwiki.ini.cgi

skin/instag.js: skin/instag.js.src skin/jqModal.js.src ${BUILDMAKER}
	cat skin/instag.js.src skin/jqModal.js.src skin/farbtastic.js.src > skin/instag.js.1
	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/instag.js.2 skin/instag.js.1
	${PERL} ${BUILDDIR}/utf16.pl skin/instag.js.2 skin/instag.js.3
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/instag.js skin/instag.js.3
	rm -f skin/instag.js.1 skin/instag.js.2 skin/instag.js.3

skin/loader.js: skin/loader.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/loader.js skin/loader.js.src

skin/bookmark.js: skin/bookmark.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/bookmark.js skin/bookmark.js.src

skin/captcha.js: skin/captcha.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/captcha.js skin/captcha.js.src

skin/instag.css: skin/instag.css.src skin/jqModal.css.src skin/farbtastic.css.src ${BUILDMAKER}
	cat skin/instag.css.src skin/jqModal.css.src skin/farbtastic.css.src > tmpcss
	${PERL} ${BUILDDIR}/compressfile.pl css skin/instag.css tmpcss
	rm -f tmpcss

skin/passwd.js: skin/passwd.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/passwd.js skin/passwd.js.src

skin/twitter.js: skin/twitter.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/twitter.js skin/twitter.js.src

skin/twitstat.js: skin/twitstat.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js skin/twitstat.js skin/twitstat.js.src
skin/smedia.js: skin/smedia.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/smedia.js.tmp skin/smedia.js.src
	${PERL} ${BUILDDIR}/utf16.pl skin/smedia.js.tmp skin/smedia.js.t2
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/smedia.js skin/smedia.js.t2
	rm -f skin/smedia.js.tmp skin/smedia.js.t2

#skin/smedia.en.js: skin/smedia.en.js.src ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/smedia.en.js skin/smedia.en.js.src

#skin/smedia.ja.js: skin/smedia.ja.js.src ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/smedia.ja.js skin/smedia.ja.js.src

#skin/smedia.unicode.ja.js: skin/smedia.ja.js.src ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/smedia.unicode.ja.js.tmp skin/smedia.ja.js
#	${PERL} ${BUILDDIR}/utf16.pl skin/smedia.unicode.ja.js.tmp skin/smedia.unicode.ja.js
#	rm -f skin/smedia.unicode.ja.js.tmp

#skin/smedia.sjis.ja.js: skin/smedia.ja.js ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/Jcode-convert.pl sjis skin/smedia.sjis.ja.js skin/smedia.ja.js

#skin/smedia.utf8.ja.js: skin/smedia.ja.js ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/Jcode-convert.pl utf8 skin/smedia.utf8.ja.js skin/smedia.ja.js

skin/common.en.js: skin/common.en.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/common.en.js skin/common.en.js.src

skin/common.ja.js: skin/common.ja.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/common.ja.js skin/common.ja.js.src

skin/edit.en.js: skin/edit.en.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/edit.en.js skin/edit.en.js.src

skin/edit.ja.js: skin/edit.ja.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/edit.ja.js skin/edit.ja.js.src

#skin/smedia.en.js.src: skin/smedia.lang.js.src ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/lang.pl en skin/smedia.lang.js.src

#skin/smedia.ja.js.src: skin/smedia.lang.js.src ${BUILDMAKER}
#	${PERL} ${BUILDDIR}/lang.pl ja skin/smedia.lang.js.src

skin/common.en.js.src: skin/common.lang.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/lang.pl en skin/common.lang.js.src

skin/common.ja.js.src: skin/common.lang.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/lang.pl ja skin/common.lang.js.src

skin/edit.en.js.src: skin/edit.lang.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/lang.pl en skin/edit.lang.js.src

skin/edit.ja.js.src: skin/edit.lang.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/lang.pl ja skin/edit.lang.js.src

skin/pyukiwiki.default.css: skin/pyukiwiki.default.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/pyukiwiki.default.css skin/pyukiwiki.default.css.org

skin/pyukiwiki.default.css.org: skin/pyukiwiki.default.css.src skin/pyukiwiki.table.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/csscolorbuilder.pl skin/pyukiwiki.default.css.src skin/pyukiwiki.table.src > skin/pyukiwiki.default.css.org

sample/mikachan.default.css.org: skin/pyukiwiki.default.css.org
	cp skin/pyukiwiki.default.css.org sample/mikachan.default.css.org

sample/mikachan.print.css.org: skin/pyukiwiki.print.css.org
	cp skin/pyukiwiki.print.css.org sample/mikachan.print.css.org

skin/pyukiwiki.print.css: skin/pyukiwiki.print.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/pyukiwiki.print.css skin/pyukiwiki.print.css.org

skin/pyukiwikigreen.default.css: skin/pyukiwikigreen.default.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/pyukiwikigreen.default.css skin/pyukiwikigreen.default.css.org

skin/pyukiwikigreen.default.css.org: skin/pyukiwiki.default.css.src skin/pyukiwikigreen.table.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/csscolorbuilder.pl skin/pyukiwiki.default.css.src skin/pyukiwikigreen.table.src > skin/pyukiwikigreen.default.css.org

skin/pyukiwikigreen.print.css: skin/pyukiwiki.print.css ${BUILDMAKER}
	cp skin/pyukiwiki.print.css skin/pyukiwikigreen.print.css

skin/pyukiwikigreen.skin.cgi: skin/pyukiwiki.skin.cgi ${BUILDMAKER}
	cp skin/pyukiwiki.skin.cgi skin/pyukiwikigreen.skin.cgi

skin/blosxom.css: skin/blosxom.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/blosxom.css skin/blosxom.css.org

skin/logs_viewer.css: skin/logs_viewer.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/logs_viewer.css skin/logs_viewer.css.org

skin/video-js.css: skin/video-js.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/video-js.css skin/video-js.css.org

skin/tube.css: skin/tube.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/tube.css skin/tube.css.org

skin/videoresize.js: skin/videoresize.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/videoresize.js skin/videoresize.js.src

skin/video.js: skin/video.js.src skin/videoresize.js.src ${BUILDMAKER}
	cat skin/videoresize.js.src skin/video.js.src > tmpjsvideojs
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/video.js tmpjsvideojs
	rm -f tmpjsvideojs

skin/flowplayer-3.2.6.min.js: skin/flowplayer-3.2.6.min.js.src skin/videoresize.js.src ${BUILDMAKER}
	cat skin/videoresize.js.src skin/flowplayer-3.2.6.min.js.src > tmpjsflowplayer
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/flowplayer-3.2.6.min.js tmpjsflowplayer
	rm -f tmpjsflowplayer

skin/jquery.js: skin/jquery.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/jquery.js skin/jquery.js.src

skin/smedia.css: skin/smedia.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/smedia.css skin/smedia.css.org

skin/ad.css: skin/ad.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/ad.css skin/ad.css.org

sample/mikachan.default.css: sample/mikachan.default.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css sample/mikachan.default.css sample/mikachan.default.css.org

sample/mikachan.print.css: sample/mikachan.print.css.org ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css sample/mikachan.print.css sample/mikachan.print.css.org

sample/mikachan.skin.cgi: skin/pyukiwiki.skin.cgi ${BUILDMAKER}
	cp skin/pyukiwiki.skin.cgi sample/mikachan.skin.cgi

skin/syntaxhighlighter/shCore.js: skin/syntaxhighlighter/shCore.js.src skin/syntaxhighlighter/XRegExp.js.src ${BUILDMAKER}
	cat skin/syntaxhighlighter/shCore.js.src skin/syntaxhighlighter/XRegExp.js.src > tmpjsshcore
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shCore.js tmpjsshcore
	rm -f tmpjsshcore

skin/syntaxhighlighter/shAutoloader.js: skin/syntaxhighlighter/shAutoloader.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shAutoloader.js skin/syntaxhighlighter/shAutoloader.js.src

skin/syntaxhighlighter/shBrushAS3.js: skin/syntaxhighlighter/shBrushAS3.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushAS3.js skin/syntaxhighlighter/shBrushAS3.js.src

skin/syntaxhighlighter/shBrushAppleScript.js: skin/syntaxhighlighter/shBrushAppleScript.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushAppleScript.js skin/syntaxhighlighter/shBrushAppleScript.js.src

skin/syntaxhighlighter/shBrushBash.js: skin/syntaxhighlighter/shBrushBash.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushBash.js skin/syntaxhighlighter/shBrushBash.js.src

skin/syntaxhighlighter/shBrushCSharp.js: skin/syntaxhighlighter/shBrushCSharp.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushCSharp.js skin/syntaxhighlighter/shBrushCSharp.js.src

skin/syntaxhighlighter/shBrushColdFusion.js: skin/syntaxhighlighter/shBrushColdFusion.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushColdFusion.js skin/syntaxhighlighter/shBrushColdFusion.js.src

skin/syntaxhighlighter/shBrushCpp.js: skin/syntaxhighlighter/shBrushCpp.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushCpp.js skin/syntaxhighlighter/shBrushCpp.js.src

skin/syntaxhighlighter/shBrushCss.js: skin/syntaxhighlighter/shBrushCss.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushCss.js skin/syntaxhighlighter/shBrushCss.js.src

skin/syntaxhighlighter/shBrushDelphi.js: skin/syntaxhighlighter/shBrushDelphi.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushDelphi.js skin/syntaxhighlighter/shBrushDelphi.js.src

skin/syntaxhighlighter/shBrushDiff.js: skin/syntaxhighlighter/shBrushDiff.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushDiff.js skin/syntaxhighlighter/shBrushDiff.js.src

skin/syntaxhighlighter/shBrushErlang.js: skin/syntaxhighlighter/shBrushErlang.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushErlang.js skin/syntaxhighlighter/shBrushErlang.js.src

skin/syntaxhighlighter/shBrushGroovy.js: skin/syntaxhighlighter/shBrushGroovy.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushGroovy.js skin/syntaxhighlighter/shBrushGroovy.js.src

skin/syntaxhighlighter/shBrushJScript.js: skin/syntaxhighlighter/shBrushJScript.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushJScript.js skin/syntaxhighlighter/shBrushJScript.js.src

skin/syntaxhighlighter/shBrushJava.js: skin/syntaxhighlighter/shBrushJava.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushJava.js skin/syntaxhighlighter/shBrushJava.js.src

skin/syntaxhighlighter/shBrushJavaFX.js: skin/syntaxhighlighter/shBrushJavaFX.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushJavaFX.js skin/syntaxhighlighter/shBrushJavaFX.js.src

skin/syntaxhighlighter/shBrushPerl.js: skin/syntaxhighlighter/shBrushPerl.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushPerl.js skin/syntaxhighlighter/shBrushPerl.js.src

skin/syntaxhighlighter/shBrushPhp.js: skin/syntaxhighlighter/shBrushPhp.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushPhp.js skin/syntaxhighlighter/shBrushPhp.js.src

skin/syntaxhighlighter/shBrushPlain.js: skin/syntaxhighlighter/shBrushPlain.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushPlain.js skin/syntaxhighlighter/shBrushPlain.js.src

skin/syntaxhighlighter/shBrushPowerShell.js: skin/syntaxhighlighter/shBrushPowerShell.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushPowerShell.js skin/syntaxhighlighter/shBrushPowerShell.js.src

skin/syntaxhighlighter/shBrushPython.js: skin/syntaxhighlighter/shBrushPython.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushPython.js skin/syntaxhighlighter/shBrushPython.js.src

skin/syntaxhighlighter/shBrushRuby.js: skin/syntaxhighlighter/shBrushRuby.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushRuby.js skin/syntaxhighlighter/shBrushRuby.js.src

skin/syntaxhighlighter/shBrushSass.js: skin/syntaxhighlighter/shBrushSass.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushSass.js skin/syntaxhighlighter/shBrushSass.js.src

skin/syntaxhighlighter/shBrushScala.js: skin/syntaxhighlighter/shBrushScala.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushScala.js skin/syntaxhighlighter/shBrushScala.js.src

skin/syntaxhighlighter/shBrushSql.js: skin/syntaxhighlighter/shBrushSql.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushSql.js skin/syntaxhighlighter/shBrushSql.js.src

skin/syntaxhighlighter/shBrushVb.js: skin/syntaxhighlighter/shBrushVb.js.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushVb.js skin/syntaxhighlighter/shBrushVb.js.src

skin/syntaxhighlighter/shBrushXml.js: skin/syntaxhighlighter/shBrushXml.js.src ${BUILDMAKER}	
	${PERL} ${BUILDDIR}/compressfile.pl js2 skin/syntaxhighlighter/shBrushXml.js skin/syntaxhighlighter/shBrushXml.js.src

skin/syntaxhighlighter/shCore.css: skin/syntaxhighlighter/shCore.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shCore.css skin/syntaxhighlighter/shCore.css.src

skin/syntaxhighlighter/shThemeDefault.css: skin/syntaxhighlighter/shThemeDefault.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeDefault.css skin/syntaxhighlighter/shThemeDefault.css.src

skin/syntaxhighlighter/shThemeDjango.css: skin/syntaxhighlighter/shThemeDjango.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeDjango.css skin/syntaxhighlighter/shThemeDjango.css.src

skin/syntaxhighlighter/shThemeEclipse.css: skin/syntaxhighlighter/shThemeEclipse.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeEclipse.css skin/syntaxhighlighter/shThemeEclipse.css.src

skin/syntaxhighlighter/shThemeEmacs.css: skin/syntaxhighlighter/shThemeEmacs.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeEmacs.css skin/syntaxhighlighter/shThemeEmacs.css.src

skin/syntaxhighlighter/shThemeFadeToGrey.css: skin/syntaxhighlighter/shThemeFadeToGrey.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeFadeToGrey.css skin/syntaxhighlighter/shThemeFadeToGrey.css.src

skin/syntaxhighlighter/shThemeMDUltra.css: skin/syntaxhighlighter/shThemeMDUltra.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeMDUltra.css skin/syntaxhighlighter/shThemeMDUltra.css.src

skin/syntaxhighlighter/shThemeMidnight.css: skin/syntaxhighlighter/shThemeMidnight.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeMidnight.css skin/syntaxhighlighter/shThemeMidnight.css.src

skin/syntaxhighlighter/shThemeRDark.css: skin/syntaxhighlighter/shThemeRDark.css.src ${BUILDMAKER}
	${PERL} ${BUILDDIR}/compressfile.pl css skin/syntaxhighlighter/shThemeRDark.css skin/syntaxhighlighter/shThemeRDark.css.src

lib/wiki_sub.cgi: lib/wiki_auth.cgi lib/wiki_db.cgi lib/wiki_func.cgi lib/wiki_html.cgi lib/wiki_http.cgi lib/wiki_init.cgi lib/wiki_link.cgi lib/wiki_plugin.cgi lib/wiki_spam.cgi lib/wiki_wiki.cgi lib/wiki_write.cgi ${BUILDMAKER}
	${PERL} ${BUILDDIR}/makewikisub.pl lib/wiki_*.cgi >lib/wiki_sub.cgi

ftp:
	@echo "Uploading public file mirrorling"
	${PERL} ${BUILDDIR}/ftp.pl

skin/loader.js.gz: skin/loader.js
	rm -f skin/loader.js.gz
	cat skin/loader.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/loader.js.tmp
	${GZIP_JC} skin/loader.js.gz < skin/loader.js.tmp >/dev/null
	rm -f skin/loader.js.tmp

skin/bookmark.js.gz: skin/bookmark.js
	rm -f skin/bookmark.js.gz
	cat skin/bookmark.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/bookmark.js.tmp
	${GZIP_JC} skin/bookmark.js.gz < skin/bookmark.js.tmp >/dev/null
	rm -f skin/bookmark.js.tmp

skin/captcha.js.gz: skin/captcha.js
	rm -f skin/captcha.js.gz
	cat skin/captcha.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/captcha.js.tmp
	${GZIP_JC} skin/captcha.js.gz < skin/captcha.js.tmp >/dev/null
	rm -f skin/captcha.js.tmp

skin/instag.js.gz: skin/instag.js
	rm -f skin/instag.js.gz
	cat skin/instag.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/instag.js.tmp
	${GZIP_JC} skin/instag.js.gz < skin/instag.js.tmp >/dev/null
	rm -f skin/instag.js.tmp

skin/instag.css.gz: skin/instag.css
	rm -f skin/instag.css.gz
	cat skin/instag.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/instag.css.tmp
	${GZIP_JC} skin/instag.css.gz < skin/instag.css.tmp >/dev/null
	rm -f skin/instag.css.tmp

skin/common.en.js.gz: skin/common.en.js
	rm -f skin/common.en.js.gz
	cat skin/common.en.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/common.en.js.tmp
	${GZIP_JC} skin/common.en.js.gz < skin/common.en.js.tmp >/dev/null
	rm -f skin/common.en.js.tmp

skin/common.ja.js.gz: skin/common.ja.js
	rm -f skin/common.ja.js.gz
	cat skin/common.ja.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/common.ja.js.tmp
	${GZIP_JC} skin/common.ja.js.gz < skin/common.ja.js.tmp >/dev/null
	rm -f skin/common.ja.js.tmp

skin/common.sjis.ja.js.gz: skin/common.sjis.ja.js
	rm -f skin/common.sjis.ja.js.gz
	cat skin/common.sjis.ja.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/common.sjis.ja.js.tmp
	${GZIP_JC} skin/common.sjis.ja.js.gz < skin/common.sjis.ja.js.tmp >/dev/null
	rm -f skin/common.sjis.ja.js.tmp

skin/common.utf8.ja.js.gz: skin/common.utf8.ja.js
	rm -f skin/common.utf8.ja.js.gz
	cat skin/common.utf8.ja.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/common.utf8.ja.js.tmp
	${GZIP_JC} skin/common.utf8.ja.js.gz < skin/common.utf8.ja.js.tmp >/dev/null
	rm -f skin/common.utf8.ja.js.tmp

skin/common.unicode.ja.js.gz: skin/common.unicode.ja.js
	rm -f skin/common.unicode.ja.js.gz
	cat skin/common.unicode.ja.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/common.unicode.ja.js.tmp
	${GZIP_JC} skin/common.unicode.ja.js.gz < skin/common.unicode.ja.js.tmp >/dev/null
	rm -f skin/common.unicode.ja.js.tmp

skin/edit.js.gz: skin/edit.js
	rm -f skin/edit.js.gz
	cat skin/edit.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/edit.js.tmp
	${GZIP_JC} skin/edit.js.gz < skin/edit.js.tmp >/dev/null
	rm -f skin/edit.js.tmp

skin/passwd.js.gz: skin/passwd.js
	rm -f skin/passwd.js.gz
	cat skin/passwd.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/passwd.js.tmp
	${GZIP_JC} skin/passwd.js.gz < skin/passwd.js.tmp >/dev/null
	rm -f skin/passwd.js.tmp

skin/twitter.js.gz: skin/twitter.js
	rm -f skin/twitter.js.gz
	cat skin/twitter.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/twitter.js.tmp
	${GZIP_JC} skin/twitter.js.gz < skin/twitter.js.tmp >/dev/null
	rm -f skin/twitter.js.tmp

skin/twitstat.js.gz: skin/twitstat.js
	rm -f skin/twitstat.js.gz
	cat skin/twitstat.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/twitstat.js.tmp
	${GZIP_JC} skin/twitstat.js.gz < skin/twitstat.js.tmp >/dev/null
	rm -f skin/twitstat.js.tmp

skin/smedia.js.gz: skin/smedia.js
	rm -f skin/smedia.js.gz
	cat skin/smedia.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/smedia.js.tmp
	${GZIP_JC} skin/smedia.js.gz < skin/smedia.js.tmp >/dev/null
	rm -f skin/smedia.js.tmp

skin/smedia.css.gz: skin/smedia.css
	rm -f skin/smedia.css.gz
	cat skin/smedia.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/smedia.css.tmp
	${GZIP_JC} skin/smedia.css.gz < skin/smedia.css.tmp >/dev/null
	rm -f skin/smedia.css.tmp

skin/pyukiwiki.default.css.gz: skin/pyukiwiki.default.css
	rm -f skin/pyukiwiki.default.css.gz
	cat skin/pyukiwiki.default.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/pyukiwiki.default.css.tmp
	${GZIP_JC} skin/pyukiwiki.default.css.gz < skin/pyukiwiki.default.css.tmp >/dev/null
	rm -f skin/pyukiwiki.default.css.tmp

skin/pyukiwiki.print.css.gz: skin/pyukiwiki.print.css
	rm -f skin/pyukiwiki.print.css.gz
	cat skin/pyukiwiki.print.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/pyukiwiki.print.css.tmp
	${GZIP_JC} skin/pyukiwiki.print.css.gz < skin/pyukiwiki.print.css.tmp >/dev/null
	rm -f skin/pyukiwiki.print.css.tmp

skin/pyukiwikigreen.default.css.gz: skin/pyukiwikigreen.default.css
	rm -f skin/pyukiwikigreen.default.css.gz
	cat skin/pyukiwikigreen.default.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/pyukiwikigreen.default.css.tmp
	${GZIP_JC} skin/pyukiwikigreen.default.css.gz < skin/pyukiwikigreen.default.css.tmp >/dev/null
	rm -f skin/pyukiwikigreen.default.css.tmp

skin/pyukiwikigreen.print.css.gz: skin/pyukiwikigreen.print.css
	rm -f skin/pyukiwikigreen.print.css.gz
	cat skin/pyukiwikigreen.print.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/pyukiwikigreen.print.css.tmp
	${GZIP_JC} skin/pyukiwikigreen.print.css.gz < skin/pyukiwikigreen.print.css.tmp >/dev/null
	rm -f skin/pyukiwikigreen.print.css.tmp

skin/video.js.gz: skin/video.js
	rm -f skin/video.js.gz
	cat skin/video.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/video.js.tmp
	${GZIP_JC} skin/video.js.gz < skin/video.js.tmp >/dev/null
	rm -f skin/video.js.tmp

skin/flowplayer-3.2.6.min.js.gz: skin/flowplayer-3.2.6.min.js
	rm -f skin/flowplayer-3.2.6.min.js.gz
	cat skin/flowplayer-3.2.6.min.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/flowplayer-3.2.6.min.js.tmp
	${GZIP_JC} skin/flowplayer-3.2.6.min.js.gz < skin/flowplayer-3.2.6.min.js.tmp >/dev/null
	rm -f skin/flowplayer-3.2.6.min.js.tmp

skin/jquery.js.gz: skin/jquery.js
	rm -f skin/jquery.js.gz
	cat skin/jquery.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/jquery.js.tmp
	${GZIP_JC} skin/jquery.js.gz < skin/jquery.js.tmp >/dev/null
	rm -f skin/jquery.js.tmp

skin/videoresize.js.gz: skin/videoresize.js
	rm -f skin/videoresize.js.gz
	cat skin/videoresize.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/videoresize.js.tmp
	${GZIP_JC} skin/videoresize.js.gz < skin/videoresize.js.tmp >/dev/null
	rm -f skin/videoresize.js.tmp

skin/video-js.css.gz: skin/video-js.css
	rm -f skin/video-js.css.gz
	cat skin/video-js.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/video-js.css.tmp
	${GZIP_JC} skin/video-js.css.gz < skin/video-js.css.tmp >/dev/null
	rm -f skin/video-js.css.tmp

skin/tube.css.gz: skin/tube.css
	rm -f skin/tube.css.gz
	cat skin/tube.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/tube.css.tmp
	${GZIP_JC} skin/tube.css.gz < skin/tube.css.tmp >/dev/null
	rm -f skin/tube.css.tmp

skin/ad.css.gz: skin/ad.css
	rm -f skin/ad.css.gz
	cat skin/ad.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/ad.css.tmp
	${GZIP_JC} skin/ad.css.gz < skin/ad.css.tmp >/dev/null
	rm -f skin/ad.css.tmp

skin/syntaxhighlighter/shAutoloader.js.gz: skin/syntaxhighlighter/shAutoloader.js
	rm -f skin/syntaxhighlighter/shAutoloader.js.gz
	cat skin/syntaxhighlighter/shAutoloader.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shAutoloader.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shAutoloader.js.gz < skin/syntaxhighlighter/shAutoloader.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shAutoloader.js.tmp

skin/syntaxhighlighter/shBrushAS3.js.gz: skin/syntaxhighlighter/shBrushAS3.js
	rm -f skin/syntaxhighlighter/shBrushAS3.js.gz
	cat skin/syntaxhighlighter/shBrushAS3.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushAS3.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushAS3.js.gz < skin/syntaxhighlighter/shBrushAS3.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushAS3.js.tmp

skin/syntaxhighlighter/shBrushAppleScript.js.gz: skin/syntaxhighlighter/shBrushAppleScript.js
	rm -f skin/syntaxhighlighter/shBrushAppleScript.js.gz
	cat skin/syntaxhighlighter/shBrushAppleScript.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushAppleScript.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushAppleScript.js.gz < skin/syntaxhighlighter/shBrushAppleScript.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushAppleScript.js.tmp

skin/syntaxhighlighter/shBrushBash.js.gz: skin/syntaxhighlighter/shBrushBash.js
	rm -f skin/syntaxhighlighter/shBrushBash.js.gz
	cat skin/syntaxhighlighter/shBrushBash.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushBash.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushBash.js.gz < skin/syntaxhighlighter/shBrushBash.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushBash.js.tmp

skin/syntaxhighlighter/shBrushCSharp.js.gz: skin/syntaxhighlighter/shBrushCSharp.js
	rm -f skin/syntaxhighlighter/shBrushCSharp.js.gz
	cat skin/syntaxhighlighter/shBrushCSharp.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushCSharp.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushCSharp.js.gz < skin/syntaxhighlighter/shBrushCSharp.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushCSharp.js.tmp

skin/syntaxhighlighter/shBrushColdFusion.js.gz: skin/syntaxhighlighter/shBrushColdFusion.js
	rm -f skin/syntaxhighlighter/shBrushColdFusion.js.gz
	cat skin/syntaxhighlighter/shBrushColdFusion.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushColdFusion.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushColdFusion.js.gz < skin/syntaxhighlighter/shBrushColdFusion.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushColdFusion.js.tmp

skin/syntaxhighlighter/shBrushCpp.js.gz: skin/syntaxhighlighter/shBrushCpp.js
	rm -f skin/syntaxhighlighter/shBrushCpp.js.gz
	cat skin/syntaxhighlighter/shBrushCpp.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushCpp.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushCpp.js.gz < skin/syntaxhighlighter/shBrushCpp.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushCpp.js.tmp

skin/syntaxhighlighter/shBrushCss.js.gz: skin/syntaxhighlighter/shBrushCss.js
	rm -f skin/syntaxhighlighter/shBrushCss.js.gz
	cat skin/syntaxhighlighter/shBrushCss.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushCss.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushCss.js.gz < skin/syntaxhighlighter/shBrushCss.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushCss.js.tmp

skin/syntaxhighlighter/shBrushDelphi.js.gz: skin/syntaxhighlighter/shBrushDelphi.js
	rm -f skin/syntaxhighlighter/shBrushDelphi.js.gz
	cat skin/syntaxhighlighter/shBrushDelphi.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushDelphi.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushDelphi.js.gz < skin/syntaxhighlighter/shBrushDelphi.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushDelphi.js.tmp

skin/syntaxhighlighter/shBrushDiff.js.gz: skin/syntaxhighlighter/shBrushDiff.js
	rm -f skin/syntaxhighlighter/shBrushDiff.js.gz
	cat skin/syntaxhighlighter/shBrushDiff.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushDiff.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushDiff.js.gz < skin/syntaxhighlighter/shBrushDiff.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushDiff.js.tmp

skin/syntaxhighlighter/shBrushErlang.js.gz: skin/syntaxhighlighter/shBrushErlang.js
	rm -f skin/syntaxhighlighter/shBrushErlang.js.gz
	cat skin/syntaxhighlighter/shBrushErlang.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushErlang.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushErlang.js.gz < skin/syntaxhighlighter/shBrushErlang.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushErlang.js.tmp

skin/syntaxhighlighter/shBrushGroovy.js.gz: skin/syntaxhighlighter/shBrushGroovy.js
	rm -f skin/syntaxhighlighter/shBrushGroovy.js.gz
	cat skin/syntaxhighlighter/shBrushGroovy.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushGroovy.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushGroovy.js.gz < skin/syntaxhighlighter/shBrushGroovy.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushGroovy.js.tmp

skin/syntaxhighlighter/shBrushJScript.js.gz: skin/syntaxhighlighter/shBrushJScript.js
	rm -f skin/syntaxhighlighter/shBrushJScript.js.gz
	cat skin/syntaxhighlighter/shBrushJScript.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushJScript.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushJScript.js.gz < skin/syntaxhighlighter/shBrushJScript.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushJScript.js.tmp

skin/syntaxhighlighter/shBrushJava.js.gz: skin/syntaxhighlighter/shBrushJava.js
	rm -f skin/syntaxhighlighter/shBrushJava.js.gz
	cat skin/syntaxhighlighter/shBrushJava.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushJava.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushJava.js.gz < skin/syntaxhighlighter/shBrushJava.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushJava.js.tmp

skin/syntaxhighlighter/shBrushJavaFX.js.gz: skin/syntaxhighlighter/shBrushJavaFX.js
	rm -f skin/syntaxhighlighter/shBrushJavaFX.js.gz
	cat skin/syntaxhighlighter/shBrushJavaFX.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushJavaFX.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushJavaFX.js.gz < skin/syntaxhighlighter/shBrushJavaFX.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushJavaFX.js.tmp

skin/syntaxhighlighter/shBrushPerl.js.gz: skin/syntaxhighlighter/shBrushPerl.js
	rm -f skin/syntaxhighlighter/shBrushPerl.js.gz
	cat skin/syntaxhighlighter/shBrushPerl.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushPerl.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushPerl.js.gz < skin/syntaxhighlighter/shBrushPerl.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushPerl.js.tmp

skin/syntaxhighlighter/shBrushPhp.js.gz: skin/syntaxhighlighter/shBrushPhp.js
	rm -f skin/syntaxhighlighter/shBrushPhp.js.gz
	cat skin/syntaxhighlighter/shBrushPhp.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushPhp.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushPhp.js.gz < skin/syntaxhighlighter/shBrushPhp.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushPhp.js.tmp

skin/syntaxhighlighter/shBrushPlain.js.gz: skin/syntaxhighlighter/shBrushPlain.js
	rm -f skin/syntaxhighlighter/shBrushPlain.js.gz
	cat skin/syntaxhighlighter/shBrushPlain.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushPlain.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushPlain.js.gz < skin/syntaxhighlighter/shBrushPlain.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushPlain.js.tmp

skin/syntaxhighlighter/shBrushPowerShell.js.gz: skin/syntaxhighlighter/shBrushPowerShell.js
	rm -f skin/syntaxhighlighter/shBrushPowerShell.js.gz
	cat skin/syntaxhighlighter/shBrushPowerShell.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushPowerShell.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushPowerShell.js.gz < skin/syntaxhighlighter/shBrushPowerShell.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushPowerShell.js.tmp

skin/syntaxhighlighter/shBrushPython.js.gz: skin/syntaxhighlighter/shBrushPython.js
	rm -f skin/syntaxhighlighter/shBrushPython.js.gz
	cat skin/syntaxhighlighter/shBrushPython.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushPython.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushPython.js.gz < skin/syntaxhighlighter/shBrushPython.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushPython.js.tmp

skin/syntaxhighlighter/shBrushRuby.js.gz: skin/syntaxhighlighter/shBrushRuby.js
	rm -f skin/syntaxhighlighter/shBrushRuby.js.gz
	cat skin/syntaxhighlighter/shBrushRuby.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushRuby.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushRuby.js.gz < skin/syntaxhighlighter/shBrushRuby.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushRuby.js.tmp

skin/syntaxhighlighter/shBrushSass.js.gz: skin/syntaxhighlighter/shBrushSass.js
	rm -f skin/syntaxhighlighter/shBrushSass.js.gz
	cat skin/syntaxhighlighter/shBrushSass.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushSass.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushSass.js.gz < skin/syntaxhighlighter/shBrushSass.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushSass.js.tmp

skin/syntaxhighlighter/shBrushScala.js.gz: skin/syntaxhighlighter/shBrushScala.js
	rm -f skin/syntaxhighlighter/shBrushScala.js.gz
	cat skin/syntaxhighlighter/shBrushScala.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushScala.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushScala.js.gz < skin/syntaxhighlighter/shBrushScala.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushScala.js.tmp

skin/syntaxhighlighter/shBrushSql.js.gz: skin/syntaxhighlighter/shBrushSql.js
	rm -f skin/syntaxhighlighter/shBrushSql.js.gz
	cat skin/syntaxhighlighter/shBrushSql.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushSql.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushSql.js.gz < skin/syntaxhighlighter/shBrushSql.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushSql.js.tmp

skin/syntaxhighlighter/shBrushVb.js.gz: skin/syntaxhighlighter/shBrushVb.js
	rm -f skin/syntaxhighlighter/shBrushVb.js.gz
	cat skin/syntaxhighlighter/shBrushVb.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushVb.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushVb.js.gz < skin/syntaxhighlighter/shBrushVb.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushVb.js.tmp

skin/syntaxhighlighter/shBrushXml.js.gz: skin/syntaxhighlighter/shBrushXml.js
	rm -f skin/syntaxhighlighter/shBrushXml.js.gz
	cat skin/syntaxhighlighter/shBrushXml.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shBrushXml.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shBrushXml.js.gz < skin/syntaxhighlighter/shBrushXml.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shBrushXml.js.tmp

skin/syntaxhighlighter/shCore.css.gz: skin/syntaxhighlighter/shCore.css
	rm -f skin/syntaxhighlighter/shCore.css.gz
	cat skin/syntaxhighlighter/shCore.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shCore.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shCore.css.gz < skin/syntaxhighlighter/shCore.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shCore.css.tmp

skin/syntaxhighlighter/shCore.js.gz: skin/syntaxhighlighter/shCore.js
	rm -f skin/syntaxhighlighter/shCore.js.gz
	cat skin/syntaxhighlighter/shCore.js|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shCore.js.tmp
	${GZIP_JC} skin/syntaxhighlighter/shCore.js.gz < skin/syntaxhighlighter/shCore.js.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shCore.js.tmp

skin/syntaxhighlighter/shThemeDefault.css.gz: skin/syntaxhighlighter/shThemeDefault.css
	rm -f skin/syntaxhighlighter/shThemeDefault.css.gz
	cat skin/syntaxhighlighter/shThemeDefault.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeDefault.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeDefault.css.gz < skin/syntaxhighlighter/shThemeDefault.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeDefault.css.tmp

skin/syntaxhighlighter/shThemeDjango.css.gz: skin/syntaxhighlighter/shThemeDjango.css
	rm -f skin/syntaxhighlighter/shThemeDjango.css.gz
	cat skin/syntaxhighlighter/shThemeDjango.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeDjango.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeDjango.css.gz < skin/syntaxhighlighter/shThemeDjango.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeDjango.css.tmp

skin/syntaxhighlighter/shThemeEclipse.css.gz: skin/syntaxhighlighter/shThemeEclipse.css
	rm -f skin/syntaxhighlighter/shThemeEclipse.css.gz
	cat skin/syntaxhighlighter/shThemeEclipse.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeEclipse.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeEclipse.css.gz < skin/syntaxhighlighter/shThemeEclipse.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeEclipse.css.tmp

skin/syntaxhighlighter/shThemeEmacs.css.gz: skin/syntaxhighlighter/shThemeEmacs.css
	rm -f skin/syntaxhighlighter/shThemeEmacs.css.gz
	cat skin/syntaxhighlighter/shThemeEmacs.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeEmacs.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeEmacs.css.gz < skin/syntaxhighlighter/shThemeEmacs.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeEmacs.css.tmp

skin/syntaxhighlighter/shThemeFadeToGrey.css.gz: skin/syntaxhighlighter/shThemeFadeToGrey.css
	rm -f skin/syntaxhighlighter/shThemeFadeToGrey.css.gz
	cat skin/syntaxhighlighter/shThemeFadeToGrey.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeFadeToGrey.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeFadeToGrey.css.gz < skin/syntaxhighlighter/shThemeFadeToGrey.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeFadeToGrey.css.tmp

skin/syntaxhighlighter/shThemeMDUltra.css.gz: skin/syntaxhighlighter/shThemeMDUltra.css
	rm -f skin/syntaxhighlighter/shThemeMDUltra.css.gz
	cat skin/syntaxhighlighter/shThemeMDUltra.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeMDUltra.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeMDUltra.css.gz < skin/syntaxhighlighter/shThemeMDUltra.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeMDUltra.css.tmp

skin/syntaxhighlighter/shThemeMidnight.css.gz: skin/syntaxhighlighter/shThemeMidnight.css
	rm -f skin/syntaxhighlighter/shThemeMidnight.css.gz
	cat skin/syntaxhighlighter/shThemeMidnight.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeMidnight.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeMidnight.css.gz < skin/syntaxhighlighter/shThemeMidnight.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeMidnight.css.tmp

skin/syntaxhighlighter/shThemeRDark.css.gz: skin/syntaxhighlighter/shThemeRDark.css
	rm -f skin/syntaxhighlighter/shThemeRDark.css.gz
	cat skin/syntaxhighlighter/shThemeRDark.css|grep -v '^\/\*'|grep -v '^ \*'|grep -v '^ \*\/' > skin/syntaxhighlighter/shThemeRDark.css.tmp
	${GZIP_JC} skin/syntaxhighlighter/shThemeRDark.css.gz < skin/syntaxhighlighter/shThemeRDark.css.tmp >/dev/null
	rm -f skin/syntaxhighlighter/shThemeRDark.css.tmp

